package bz.bronze.pixels;

public class Gameloop implements Runnable {

    private Thread thread;
    private Renderer renderer;

    private boolean running = false;
    private final double TPS = 1.0/60.0;
    
    public void start() {
        renderer = new Renderer();
        
        thread = new Thread(this);
        thread.run();
    }

    public void stop() {

    }

    public void run() {
        running = true;

        boolean render = false;

        double firstTime = 0;
        double lastTime = System.nanoTime() / 1000000000.0;
        double passedTime = 0;
        double unprocessedTime = 0;

        double tickTime = 0;
        int ticks = 0;
        int tps = 0;
        
        while (running) {
            render = false;

            firstTime = System.nanoTime() / 1000000000.0;
            passedTime = firstTime - lastTime;
            lastTime = firstTime;

            unprocessedTime += passedTime;
            tickTime += passedTime;

            while (unprocessedTime >= TPS) {
                unprocessedTime -= TPS;

                render = true;

                if (tickTime >= 1.0) {
                    tickTime = 0;
                    tps = ticks;
                    ticks = 0;
                }

                System.out.println("TPS: " + tps);
            }

            if (render) {
                renderer.clear();
                
                Window.update();
                ticks++;
            } else {
                try {
                    Thread.sleep(1);
                } catch (InterruptedException e) {
                    e.printStackTrace();   
                }
            }
        }

        dispose();
    }

    public void dispose() {
        
    }
}